Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -10073,7 +9607,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( salsa_gas(icc)%conc(k,j,i),     &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10088,7 +9622,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),          &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10101,19 +9635,19 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
+                      DO  b = 1, nbins
 !                      
 !--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,n) * 2.0_wp 
+                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp 
 !                               
 !--                      Deposition factor: alveolar                             
                          df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp *     &
-                                ( LOG( mean_d ) + 2.84_wp )**2.0_wp )          &
-                                  + 19.11_wp * EXP( -0.482_wp *                &
-                                  ( LOG( mean_d ) - 1.362_wp )**2.0_wp ) )
+                              ( LOG( mean_d ) + 2.84_wp )**2.0_wp ) + 19.11_wp &
+                              * EXP( -0.482_wp * ( LOG( mean_d ) - 1.362_wp    &
+                                )**2.0_wp ) )
 !                                    
 !--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(n)%conc(k,j,i)
+                         nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)
 !                         
 !--                      Lung-deposited surface area LDSA (units mum2/cm3)
@@ -10121,5 +9655,5 @@
                       ENDDO
                       local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10129,7 +9663,44 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( LDSA_av(k,j,i),                 &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+          
+       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6',   &
+              'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) b = 1
+          IF ( TRIM( variable(6:) ) == '2' ) b = 2
+          IF ( TRIM( variable(6:) ) == '3' ) b = 3
+          IF ( TRIM( variable(6:) ) == '4' ) b = 4
+          IF ( TRIM( variable(6:) ) == '5' ) b = 5
+          IF ( TRIM( variable(6:) ) == '6' ) b = 6
+          IF ( TRIM( variable(6:) ) == '7' ) b = 7
+          IF ( TRIM( variable(6:) ) == '8' ) b = 8
+          IF ( TRIM( variable(6:) ) == '9' ) b = 9
+          IF ( TRIM( variable(6:) ) == '10' ) b = 10
+          IF ( TRIM( variable(6:) ) == '11' ) b = 11
+          IF ( TRIM( variable(6:) ) == '12' ) b = 12
+          
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do                      
+                      local_pf(i,j,k) = MERGE( aerosol_number(b)%conc(k,j,i),  &
+                                               REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do                      
+                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,b),              &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10142,11 +9713,11 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins                         
-                         temp_bin = temp_bin + aerosol_number(n)%conc(k,j,i)
+                      DO  b = 1, nbins                         
+                         temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
                       ENDDO
                       local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10156,7 +9727,48 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( Ntot_av(k,j,i),                 &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+          
+       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6',   &
+              'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) b = 1
+          IF ( TRIM( variable(6:) ) == '2' ) b = 2
+          IF ( TRIM( variable(6:) ) == '3' ) b = 3
+          IF ( TRIM( variable(6:) ) == '4' ) b = 4
+          IF ( TRIM( variable(6:) ) == '5' ) b = 5
+          IF ( TRIM( variable(6:) ) == '6' ) b = 6
+          IF ( TRIM( variable(6:) ) == '7' ) b = 7
+          IF ( TRIM( variable(6:) ) == '8' ) b = 8
+          IF ( TRIM( variable(6:) ) == '9' ) b = 9
+          IF ( TRIM( variable(6:) ) == '10' ) b = 10
+          IF ( TRIM( variable(6:) ) == '11' ) b = 11
+          IF ( TRIM( variable(6:) ) == '12' ) b = 12
+          
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do   
+                      temp_bin = 0.0_wp
+                      DO  c = b, ncc_tot * nbins, nbins
+                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      ENDDO
+                      local_pf(i,j,k) = MERGE( temp_bin,                       &
+                                               REAL( fill_value, KIND = wp ),  &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_do, nzt_do                      
+                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,b),              &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10169,9 +9781,9 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,n) <= 2.5E-6_wp )  THEN
-                            DO  c = n, nbins*ncc, nbins
+                      DO  b = 1, nbins
+                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
+                            DO  c = b, nbins * ncc, nbins
                                temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                             ENDDO
@@ -10179,5 +9791,5 @@
                       ENDDO
                       local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10187,7 +9799,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( PM25_av(k,j,i),                 &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10200,9 +9812,9 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
-                      DO  n = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,n) <= 10.0E-6_wp )  THEN
-                            DO  c = n, nbins*ncc, nbins
+                      DO  b = 1, nbins
+                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
+                            DO  c = b, nbins * ncc, nbins
                                temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                             ENDDO
@@ -10210,5 +9822,5 @@
                       ENDDO
                       local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
